/*------------------------------------------------------------------------------
--  This file is a part of the SocExplorer Software
--  Copyright (C) 2014, Plasma Physics Laboratory - CNRS
--
--  This program is free software; you can redistribute it and/or modify
--  it under the terms of the GNU General Public License as published by
--  the Free Software Foundation; either version 2 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--  GNU General Public License for more details.
--
--  You should have received a copy of the GNU General Public License
--  along with this program; if not, write to the Free Software
--  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-------------------------------------------------------------------------------*/
/*--                  Author : Alexis Jeandet
--                     Mail : alexis.jeandet@member.fsf.org
----------------------------------------------------------------------------*/
#include "apbuart_plugin_ui.h"
#include "ui_apbuart_plugin_ui.h"
#include "apbuartterminal.h"

APBUART_Plugin_ui::APBUART_Plugin_ui(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::APBUART_Plugin_ui)
{
    ui->setupUi(this);
    connect(this->ui->FIFODebugChkBx,SIGNAL(stateChanged(int)),this,SIGNAL(loopbackChkBxStateChanged(int)));
    connect(this,SIGNAL(apbUartTextReceived(QString)),this->ui->UART_TERM,SLOT(apbUartTextReceived(QString)));
    connect(this->ui->ConnectQpb,SIGNAL(clicked()),this,SIGNAL(connectPort()));
    connect(this->ui->UART_TERM,SIGNAL(sendChar(char)),this,SIGNAL(sendChar(char)));
    connect(this->ui->PortNameLineEdit,SIGNAL(textChanged(QString)),this,SIGNAL(PortNameChanged(QString)));
    connect(this->ui->UartSpeedLineEdit,SIGNAL(textChanged(QString)),this,SIGNAL(UartSpeedChanged(QString)));
}

APBUART_Plugin_ui::~APBUART_Plugin_ui()
{
    delete ui;
}

void APBUART_Plugin_ui::setEnableForLoopBack(bool enable)
{
    this->ui->PortNameLineEdit->setEnabled(enable);
    this->ui->ConnectQpb->setEnabled(enable);
    this->ui->UartSpeedLineEdit->setEnabled(enable);
}

void APBUART_Plugin_ui::setUartConnected(bool enable)
{
    this->ui->PortNameLineEdit->setDisabled(enable);
    this->ui->UartSpeedLineEdit->setDisabled(enable);
    this->ui->FIFODebugChkBx->setDisabled(enable);
    if(enable)
    {
        this->ui->ConnectQpb->setText("Close Port");
    }
    else
    {
        this->ui->ConnectQpb->setText("Open Port");
    }
}
